
use builtin;
use str;

set edit:completion:arg-completer[tinymist] = {|@words|
    fn spaces {|n|
        builtin:repeat $n ' ' | str:join ''
    }
    fn cand {|text desc|
        edit:complex-candidate $text &display=$text' '(spaces (- 14 (wcswidth $text)))$desc
    }
    var command = 'tinymist'
    for word $words[1..-1] {
        if (str:has-prefix $word '-') {
            break
        }
        set command = $command';'$word
    }
    var completions = [
        &'tinymist'= {
            cand -h 'Print help'
            cand --help 'Print help'
            cand -V 'Print version'
            cand --version 'Print version'
            cand completion 'Generates completion script to stdout'
            cand lsp 'Runs language server'
            cand query 'Runs language query'
            cand trace-lsp 'Runs language server for tracing some typst program'
            cand preview 'Runs preview server'
            cand probe 'Probes existence (Nop run)'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'tinymist;completion'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'tinymist;lsp'= {
            cand --mirror 'Mirror the stdin to the file'
            cand --replay 'Replay input from the file'
            cand --font-path 'Font paths'
            cand --ignore-system-fonts 'Ensures system fonts won''t be searched, unless explicitly included via `--font-path`'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'tinymist;query'= {
            cand -h 'Print help'
            cand --help 'Print help'
            cand packageDocs 'Get the documentation for a specific package'
            cand checkPackage 'Check a specific package'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'tinymist;query;packageDocs'= {
            cand --path 'The path of the package to request docs for'
            cand --id 'The package of the package to request docs for'
            cand -o 'The output path for the requested docs'
            cand --output 'The output path for the requested docs'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'tinymist;query;checkPackage'= {
            cand --path 'The path of the package to request docs for'
            cand --id 'The package of the package to request docs for'
            cand -o 'The output path for the requested docs'
            cand --output 'The output path for the requested docs'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'tinymist;query;help'= {
            cand packageDocs 'Get the documentation for a specific package'
            cand checkPackage 'Check a specific package'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'tinymist;query;help;packageDocs'= {
        }
        &'tinymist;query;help;checkPackage'= {
        }
        &'tinymist;query;help;help'= {
        }
        &'tinymist;trace-lsp'= {
            cand --rpc-kind 'rpc-kind'
            cand --mirror 'Mirror the stdin to the file'
            cand --replay 'Replay input from the file'
            cand --root 'Configures the project root (for absolute paths)'
            cand --input 'Add a string key-value pair visible through `sys.inputs`'
            cand --font-path 'Font paths'
            cand --package-path 'Custom path to local packages, defaults to system-dependent location'
            cand --package-cache-path 'Custom path to package cache, defaults to system-dependent location'
            cand --creation-timestamp 'The document''s creation date formatted as a UNIX timestamp'
            cand --cert 'Path to CA certificate file for network access, especially for downloading typst packages'
            cand --persist 'persist'
            cand --ignore-system-fonts 'Ensures system fonts won''t be searched, unless explicitly included via `--font-path`'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'tinymist;preview'= {
            cand --invert-colors 'Invert colors of the preview (useful for dark themes without cost). Please note you could see the origin colors when you hover elements in the preview'
            cand --task-id 'Used by lsp for identifying the task'
            cand --refresh-style 'Used by lsp for controlling the preview refresh style'
            cand --root 'Configures the project root (for absolute paths)'
            cand --input 'Add a string key-value pair visible through `sys.inputs`'
            cand --font-path 'Font paths'
            cand --package-path 'Custom path to local packages, defaults to system-dependent location'
            cand --package-cache-path 'Custom path to package cache, defaults to system-dependent location'
            cand --creation-timestamp 'The document''s creation date formatted as a UNIX timestamp'
            cand --cert 'Path to CA certificate file for network access, especially for downloading typst packages'
            cand --preview-mode 'Preview mode'
            cand --data-plane-host 'Data plane server will bind to this address. Note: if it equals to `static_file_host`, same address will be used'
            cand --control-plane-host 'Control plane server will bind to this address'
            cand --host '(File) Host for the preview server. Note: if it equals to `data_plane_host`, same address will be used'
            cand --partial-rendering 'Only render visible part of the document. This can improve performance but still being experimental'
            cand --ignore-system-fonts 'Ensures system fonts won''t be searched, unless explicitly included via `--font-path`'
            cand --not-primary 'Let it not be the primary instance'
            cand --no-open 'Don''t open the preview in the browser after compilation'
            cand -h 'Print help (see more with ''--help'')'
            cand --help 'Print help (see more with ''--help'')'
        }
        &'tinymist;probe'= {
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'tinymist;help'= {
            cand completion 'Generates completion script to stdout'
            cand lsp 'Runs language server'
            cand query 'Runs language query'
            cand trace-lsp 'Runs language server for tracing some typst program'
            cand preview 'Runs preview server'
            cand probe 'Probes existence (Nop run)'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'tinymist;help;completion'= {
        }
        &'tinymist;help;lsp'= {
        }
        &'tinymist;help;query'= {
            cand packageDocs 'Get the documentation for a specific package'
            cand checkPackage 'Check a specific package'
        }
        &'tinymist;help;query;packageDocs'= {
        }
        &'tinymist;help;query;checkPackage'= {
        }
        &'tinymist;help;trace-lsp'= {
        }
        &'tinymist;help;preview'= {
        }
        &'tinymist;help;probe'= {
        }
        &'tinymist;help;help'= {
        }
    ]
    $completions[$command]
}
